Index: /trunk/SophyaExt/XephemAstroLib/Makefile
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/Makefile	(revision 3086)
+++ /trunk/SophyaExt/XephemAstroLib/Makefile	(revision 3087)
@@ -6,12 +6,178 @@
 	rm -f libxastro.a *.o testxephem
 
-OBJASTRO := $(addsuffix .o,$(basename $(wildcard *.c)))
+OBJASTRO = aa_hadec.o aberration.o actan.o airmass.o anomaly.o ap_as.o atlas.o auxil.o bdl.o chap95.o chap95_data.o circum.o comet.o constel.o dbfmt.o deep.o deltat.o earthsat.o eq_ecl.o eq_gal.o formats.o helio.o jupmoon.o libration.o magdecl.o marsmoon.o misc.o mjd.o moon.o mooncolong.o moonnf.o nutation.o obliq.o parallactic.o parallax.o plans.o plmoon.o plshadow.o precess.o reduce.o refract.o rings.o riset.o riset_cir.o satmoon.o sdp4.o sgp4.o sphcart.o sun.o thetag.o twobody.o umoon.o utc_gst.o vsop87.o vsop87_data.o
 
 libxastro.a : $(OBJASTRO)
 	$(AR) $(ARFLAGS) $@ $?
 
-%.o: %.c
-	$(CCOMPILE) -o $@ $<
+aa_hadec.o: aa_hadec.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ aa_hadec.c
+
+aberration.o: aberration.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ aberration.c
+
+actan.o: actan.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ actan.c
+
+airmass.o: airmass.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ airmass.c
+
+anomaly.o: anomaly.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ anomaly.c
+
+ap_as.o: ap_as.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ ap_as.c
+
+atlas.o: atlas.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ atlas.c
+
+auxil.o: auxil.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ auxil.c
+
+bdl.o: bdl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ bdl.c
+
+chap95.o: chap95.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ chap95.c
+
+chap95_data.o: chap95_data.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ chap95_data.c
+
+circum.o: circum.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ circum.c
+
+comet.o: comet.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ comet.c
+
+constel.o: constel.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ constel.c
+
+dbfmt.o: dbfmt.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ dbfmt.c
+
+deep.o: deep.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ deep.c
+
+deltat.o: deltat.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ deltat.c
+
+earthsat.o: earthsat.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ earthsat.c
+
+eq_ecl.o: eq_ecl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ eq_ecl.c
+
+eq_gal.o: eq_gal.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ eq_gal.c
+
+formats.o: formats.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ formats.c
+
+helio.o: helio.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ helio.c
+
+jupmoon.o: jupmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ jupmoon.c
+
+libration.o: libration.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ libration.c
+
+magdecl.o: magdecl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ magdecl.c
+
+marsmoon.o: marsmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ marsmoon.c
+
+misc.o: misc.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ misc.c
+
+mjd.o: mjd.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ mjd.c
+
+moon.o: moon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ moon.c
+
+mooncolong.o: mooncolong.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ mooncolong.c
+
+moonnf.o: moonnf.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ moonnf.c
+
+nutation.o: nutation.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ nutation.c
+
+obliq.o: obliq.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ obliq.c
+
+parallactic.o: parallactic.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ parallactic.c
+
+parallax.o: parallax.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ parallax.c
+
+plans.o: plans.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plans.c
+
+plmoon.o: plmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plmoon.c
+
+plshadow.o: plshadow.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plshadow.c
+
+precess.o: precess.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ precess.c
+
+reduce.o: reduce.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ reduce.c
+
+refract.o: refract.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ refract.c
+
+rings.o: rings.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ rings.c
+
+riset.o: riset.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ riset.c
+
+riset_cir.o: riset_cir.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ riset_cir.c
+
+satmoon.o: satmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ satmoon.c
+
+sdp4.o: sdp4.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sdp4.c
+
+sgp4.o: sgp4.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sgp4.c
+
+sphcart.o: sphcart.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sphcart.c
+
+sun.o: sun.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sun.c
+
+thetag.o: thetag.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ thetag.c
+
+twobody.o: twobody.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ twobody.c
+
+umoon.o: umoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ umoon.c
+
+utc_gst.o: utc_gst.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ utc_gst.c
+
+vsop87.o: vsop87.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ vsop87.c
+
+vsop87_data.o: vsop87_data.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ vsop87_data.c
 
 testxephem: testxephem.o
 	$(CLINK) -o $@ testxephem.o -L./ -lxastro -lc -lm
+
+testxephem.o: testxephem.c astro.h
+	$(CCOMPILE) -o $@ testxephem.c
+
Index: /trunk/SophyaExt/XephemAstroLib/create_smakefile.csh
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/create_smakefile.csh	(revision 3087)
+++ /trunk/SophyaExt/XephemAstroLib/create_smakefile.csh	(revision 3087)
@@ -0,0 +1,47 @@
+#!/bin/csh
+
+rm -f smakefile Makefile maketemp
+touch smakefile Makefile maketemp
+
+set inc = ( *.h )
+set src = ( `ls -1 *.c | grep -v testxephem` )
+set obj
+foreach f ( $src )
+  set obj = ( $obj ${f:r}.o )
+end
+
+echo '' >> maketemp
+echo 'all: libxastro.a' >> maketemp
+echo '' >> maketemp
+echo 'clean:' >> maketemp
+echo '	rm -f libxastro.a *.o testxephem' >> maketemp
+echo '' >> maketemp
+echo 'OBJASTRO = '${obj} >> maketemp
+echo '' >> maketemp
+echo 'libxastro.a : $(OBJASTRO)' >> maketemp
+echo '	$(AR) $(ARFLAGS) $@ $?' >> maketemp
+echo '' >> maketemp
+
+foreach f ( $obj )
+  set c = ${f:r}.c
+  echo "${f}: ${c} ${inc}" >> maketemp
+  echo '	$(CCOMPILE) -o $@' $c >> maketemp
+  echo '' >> maketemp
+end
+
+echo 'testxephem: testxephem.o' >> maketemp
+echo '	$(CLINK) -o $@ testxephem.o -L./ -lxastro -lc -lm' >> maketemp
+echo '' >> maketemp
+echo "testxephem.o: testxephem.c astro.h" >> maketemp
+echo '	$(CCOMPILE) -o $@ testxephem.c'  >> maketemp
+echo '' >> maketemp
+
+echo 'include $(SOPHYABASE)/include/sophyamake.inc' >> smakefile
+cat maketemp >> smakefile
+
+echo 'include ../BuildMgr/sophyamake.inc' >> Makefile
+cat maketemp >> Makefile
+
+rm -f maketemp
+
+exit 0
Index: /trunk/SophyaExt/XephemAstroLib/smakefile
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/smakefile	(revision 3086)
+++ /trunk/SophyaExt/XephemAstroLib/smakefile	(revision 3087)
@@ -6,12 +6,178 @@
 	rm -f libxastro.a *.o testxephem
 
-OBJASTRO := $(addsuffix .o,$(basename $(wildcard *.c)))
+OBJASTRO = aa_hadec.o aberration.o actan.o airmass.o anomaly.o ap_as.o atlas.o auxil.o bdl.o chap95.o chap95_data.o circum.o comet.o constel.o dbfmt.o deep.o deltat.o earthsat.o eq_ecl.o eq_gal.o formats.o helio.o jupmoon.o libration.o magdecl.o marsmoon.o misc.o mjd.o moon.o mooncolong.o moonnf.o nutation.o obliq.o parallactic.o parallax.o plans.o plmoon.o plshadow.o precess.o reduce.o refract.o rings.o riset.o riset_cir.o satmoon.o sdp4.o sgp4.o sphcart.o sun.o thetag.o twobody.o umoon.o utc_gst.o vsop87.o vsop87_data.o
 
 libxastro.a : $(OBJASTRO)
 	$(AR) $(ARFLAGS) $@ $?
 
-%.o: %.c
-	$(CCOMPILE) -o $@ $<
+aa_hadec.o: aa_hadec.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ aa_hadec.c
+
+aberration.o: aberration.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ aberration.c
+
+actan.o: actan.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ actan.c
+
+airmass.o: airmass.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ airmass.c
+
+anomaly.o: anomaly.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ anomaly.c
+
+ap_as.o: ap_as.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ ap_as.c
+
+atlas.o: atlas.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ atlas.c
+
+auxil.o: auxil.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ auxil.c
+
+bdl.o: bdl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ bdl.c
+
+chap95.o: chap95.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ chap95.c
+
+chap95_data.o: chap95_data.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ chap95_data.c
+
+circum.o: circum.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ circum.c
+
+comet.o: comet.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ comet.c
+
+constel.o: constel.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ constel.c
+
+dbfmt.o: dbfmt.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ dbfmt.c
+
+deep.o: deep.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ deep.c
+
+deltat.o: deltat.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ deltat.c
+
+earthsat.o: earthsat.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ earthsat.c
+
+eq_ecl.o: eq_ecl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ eq_ecl.c
+
+eq_gal.o: eq_gal.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ eq_gal.c
+
+formats.o: formats.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ formats.c
+
+helio.o: helio.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ helio.c
+
+jupmoon.o: jupmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ jupmoon.c
+
+libration.o: libration.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ libration.c
+
+magdecl.o: magdecl.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ magdecl.c
+
+marsmoon.o: marsmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ marsmoon.c
+
+misc.o: misc.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ misc.c
+
+mjd.o: mjd.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ mjd.c
+
+moon.o: moon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ moon.c
+
+mooncolong.o: mooncolong.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ mooncolong.c
+
+moonnf.o: moonnf.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ moonnf.c
+
+nutation.o: nutation.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ nutation.c
+
+obliq.o: obliq.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ obliq.c
+
+parallactic.o: parallactic.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ parallactic.c
+
+parallax.o: parallax.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ parallax.c
+
+plans.o: plans.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plans.c
+
+plmoon.o: plmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plmoon.c
+
+plshadow.o: plshadow.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ plshadow.c
+
+precess.o: precess.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ precess.c
+
+reduce.o: reduce.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ reduce.c
+
+refract.o: refract.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ refract.c
+
+rings.o: rings.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ rings.c
+
+riset.o: riset.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ riset.c
+
+riset_cir.o: riset_cir.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ riset_cir.c
+
+satmoon.o: satmoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ satmoon.c
+
+sdp4.o: sdp4.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sdp4.c
+
+sgp4.o: sgp4.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sgp4.c
+
+sphcart.o: sphcart.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sphcart.c
+
+sun.o: sun.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ sun.c
+
+thetag.o: thetag.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ thetag.c
+
+twobody.o: twobody.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ twobody.c
+
+umoon.o: umoon.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ umoon.c
+
+utc_gst.o: utc_gst.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ utc_gst.c
+
+vsop87.o: vsop87.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ vsop87.c
+
+vsop87_data.o: vsop87_data.c astro.h bdl.h chap95.h deepconst.h preferences.h satlib.h satspec.h sattypes.h vector.h vsop87.h
+	$(CCOMPILE) -o $@ vsop87_data.c
 
 testxephem: testxephem.o
 	$(CLINK) -o $@ testxephem.o -L./ -lxastro -lc -lm
+
+testxephem.o: testxephem.c astro.h
+	$(CCOMPILE) -o $@ testxephem.c
+