Index: trunk/SophyaExt/CodeMinuit/MakeMinuit
===================================================================
--- trunk/SophyaExt/CodeMinuit/MakeMinuit	(revision 2739)
+++ trunk/SophyaExt/CodeMinuit/MakeMinuit	(revision 3088)
@@ -1,14 +1,7 @@
 include $(SOPHYABASE)/include/sophyamake.inc
 
-
-OBJ := $(addsuffix .o,$(basename $(wildcard *.F)))
-
-%.o: %.F
-	$(FCCOMPILE) -O -o $@ $<
+OBJMINUIT = minuit.o mnamin.o mnbins.o mncalf.o mncler.o mncntr.o mncomd.o mncont.o mncrck.o mncros.o mncuve.o mnderi.o mndxdi.o mneig.o mnemat.o mnerrs.o mneval.o mnexcm.o mnexin.o mnfixp.o mnfree.o mngrad.o mnhelp.o mnhes1.o mnhess.o mnimpr.o mninex.o mninit.o mninpu.o mnintr.o mnlims.o mnline.o mnmatu.o mnmigr.o mnmnos.o mnmnot.o mnparm.o mnpars.o mnpfit.o mnpint.o mnplot.o mnpout.o mnprin.o mnpsdf.o mnrazz.o mnread.o mnrn15.o mnrset.o mnsave.o mnscan.o mnseek.o mnset.o mnseti.o mnsimp.o mnstat.o mnstin.o mntiny.o mnunpt.o mnvers.o mnvert.o mnwarn.o mnwerr.o stand.o
 
 all: include libminuit.a
-
-echo:
-	@echo $(OBJ)
 
 include:
@@ -17,10 +10,199 @@
 
 clean:
-	rm -f $(OBJ)
+	rm -f $(OBJMINUIT)
 	rm -f libminuit.a minuit
 	rm -f ../examples/minuit ../examples/minexam ../examples/minexam.o ../examples/fcnk0.o
 
-libminuit.a : $(OBJ)
-	$(AR) $(ARFLAGS) $@ $(OBJ)
+libminuit.a : $(OBJMINUIT)
+	$(AR) $(ARFLAGS) $@ $(OBJMINUIT)
+
+minuit.o: minuit.F
+	$(FCCOMPILE) -o $@ minuit.F
+
+mnamin.o: mnamin.F
+	$(FCCOMPILE) -o $@ mnamin.F
+
+mnbins.o: mnbins.F
+	$(FCCOMPILE) -o $@ mnbins.F
+
+mncalf.o: mncalf.F
+	$(FCCOMPILE) -o $@ mncalf.F
+
+mncler.o: mncler.F
+	$(FCCOMPILE) -o $@ mncler.F
+
+mncntr.o: mncntr.F
+	$(FCCOMPILE) -o $@ mncntr.F
+
+mncomd.o: mncomd.F
+	$(FCCOMPILE) -o $@ mncomd.F
+
+mncont.o: mncont.F
+	$(FCCOMPILE) -o $@ mncont.F
+
+mncrck.o: mncrck.F
+	$(FCCOMPILE) -o $@ mncrck.F
+
+mncros.o: mncros.F
+	$(FCCOMPILE) -o $@ mncros.F
+
+mncuve.o: mncuve.F
+	$(FCCOMPILE) -o $@ mncuve.F
+
+mnderi.o: mnderi.F
+	$(FCCOMPILE) -o $@ mnderi.F
+
+mndxdi.o: mndxdi.F
+	$(FCCOMPILE) -o $@ mndxdi.F
+
+mneig.o: mneig.F
+	$(FCCOMPILE) -o $@ mneig.F
+
+mnemat.o: mnemat.F
+	$(FCCOMPILE) -o $@ mnemat.F
+
+mnerrs.o: mnerrs.F
+	$(FCCOMPILE) -o $@ mnerrs.F
+
+mneval.o: mneval.F
+	$(FCCOMPILE) -o $@ mneval.F
+
+mnexcm.o: mnexcm.F
+	$(FCCOMPILE) -o $@ mnexcm.F
+
+mnexin.o: mnexin.F
+	$(FCCOMPILE) -o $@ mnexin.F
+
+mnfixp.o: mnfixp.F
+	$(FCCOMPILE) -o $@ mnfixp.F
+
+mnfree.o: mnfree.F
+	$(FCCOMPILE) -o $@ mnfree.F
+
+mngrad.o: mngrad.F
+	$(FCCOMPILE) -o $@ mngrad.F
+
+mnhelp.o: mnhelp.F
+	$(FCCOMPILE) -o $@ mnhelp.F
+
+mnhes1.o: mnhes1.F
+	$(FCCOMPILE) -o $@ mnhes1.F
+
+mnhess.o: mnhess.F
+	$(FCCOMPILE) -o $@ mnhess.F
+
+mnimpr.o: mnimpr.F
+	$(FCCOMPILE) -o $@ mnimpr.F
+
+mninex.o: mninex.F
+	$(FCCOMPILE) -o $@ mninex.F
+
+mninit.o: mninit.F
+	$(FCCOMPILE) -o $@ mninit.F
+
+mninpu.o: mninpu.F
+	$(FCCOMPILE) -o $@ mninpu.F
+
+mnintr.o: mnintr.F
+	$(FCCOMPILE) -o $@ mnintr.F
+
+mnlims.o: mnlims.F
+	$(FCCOMPILE) -o $@ mnlims.F
+
+mnline.o: mnline.F
+	$(FCCOMPILE) -o $@ mnline.F
+
+mnmatu.o: mnmatu.F
+	$(FCCOMPILE) -o $@ mnmatu.F
+
+mnmigr.o: mnmigr.F
+	$(FCCOMPILE) -o $@ mnmigr.F
+
+mnmnos.o: mnmnos.F
+	$(FCCOMPILE) -o $@ mnmnos.F
+
+mnmnot.o: mnmnot.F
+	$(FCCOMPILE) -o $@ mnmnot.F
+
+mnparm.o: mnparm.F
+	$(FCCOMPILE) -o $@ mnparm.F
+
+mnpars.o: mnpars.F
+	$(FCCOMPILE) -o $@ mnpars.F
+
+mnpfit.o: mnpfit.F
+	$(FCCOMPILE) -o $@ mnpfit.F
+
+mnpint.o: mnpint.F
+	$(FCCOMPILE) -o $@ mnpint.F
+
+mnplot.o: mnplot.F
+	$(FCCOMPILE) -o $@ mnplot.F
+
+mnpout.o: mnpout.F
+	$(FCCOMPILE) -o $@ mnpout.F
+
+mnprin.o: mnprin.F
+	$(FCCOMPILE) -o $@ mnprin.F
+
+mnpsdf.o: mnpsdf.F
+	$(FCCOMPILE) -o $@ mnpsdf.F
+
+mnrazz.o: mnrazz.F
+	$(FCCOMPILE) -o $@ mnrazz.F
+
+mnread.o: mnread.F
+	$(FCCOMPILE) -o $@ mnread.F
+
+mnrn15.o: mnrn15.F
+	$(FCCOMPILE) -o $@ mnrn15.F
+
+mnrset.o: mnrset.F
+	$(FCCOMPILE) -o $@ mnrset.F
+
+mnsave.o: mnsave.F
+	$(FCCOMPILE) -o $@ mnsave.F
+
+mnscan.o: mnscan.F
+	$(FCCOMPILE) -o $@ mnscan.F
+
+mnseek.o: mnseek.F
+	$(FCCOMPILE) -o $@ mnseek.F
+
+mnset.o: mnset.F
+	$(FCCOMPILE) -o $@ mnset.F
+
+mnseti.o: mnseti.F
+	$(FCCOMPILE) -o $@ mnseti.F
+
+mnsimp.o: mnsimp.F
+	$(FCCOMPILE) -o $@ mnsimp.F
+
+mnstat.o: mnstat.F
+	$(FCCOMPILE) -o $@ mnstat.F
+
+mnstin.o: mnstin.F
+	$(FCCOMPILE) -o $@ mnstin.F
+
+mntiny.o: mntiny.F
+	$(FCCOMPILE) -o $@ mntiny.F
+
+mnunpt.o: mnunpt.F
+	$(FCCOMPILE) -o $@ mnunpt.F
+
+mnvers.o: mnvers.F
+	$(FCCOMPILE) -o $@ mnvers.F
+
+mnvert.o: mnvert.F
+	$(FCCOMPILE) -o $@ mnvert.F
+
+mnwarn.o: mnwarn.F
+	$(FCCOMPILE) -o $@ mnwarn.F
+
+mnwerr.o: mnwerr.F
+	$(FCCOMPILE) -o $@ mnwerr.F
+
+stand.o: stand.F
+	$(FCCOMPILE) -o $@ stand.F
 
 test: