Index: trunk/SophyaLib/Manual/piahelp.tex
===================================================================
--- trunk/SophyaLib/Manual/piahelp.tex	(revision 3061)
+++ trunk/SophyaLib/Manual/piahelp.tex	(revision 3093)
@@ -106,5 +106,5 @@
 readfits & p. \pageref{readfits}  & saveall & p. \pageref{saveall}  & savelist & p. \pageref{savelist}  \\  
 saveobjs & p. \pageref{saveobjs}  & saveppf & p. \pageref{saveppf}  & scanfits & p. \pageref{scanfits}  \\  
-vecfrascii & p. \pageref{vecfrascii}  & writefits & p. \pageref{writefits}  &   &   \\  
+swfitstable & p. \pageref{swfitstable}  & vecfrascii & p. \pageref{vecfrascii}  & writefits & p. \pageref{writefits}  \\  
 \end{tabular} 
 \end{center} 
@@ -228,13 +228,13 @@
 \vspace{3mm} 
 \begin{tabular}{llllll} 
-h/cadd & p. \pageref{hZcadd}  & h/cmult & p. \pageref{hZcmult}  & h/copy & p. \pageref{hZcopy}  \\  
-h/deriv & p. \pageref{hZderiv}  & h/err & p. \pageref{hZerr}  & h/get\_vec & p. \pageref{hZgetZvec}  \\  
-h/integ & p. \pageref{hZinteg}  & h/oper & p. \pageref{hZoper}  & h/plot/2d & p. \pageref{hZplotZ2d}  \\  
-h/put\_vec & p. \pageref{hZputZvec}  & h/rebin & p. \pageref{hZrebin}  & h/set/cont & p. \pageref{hZsetZcont}  \\  
-h/set/err & p. \pageref{hZsetZerr}  & n/assoc/col & p. \pageref{nZassocZcol}  & n/copy & p. \pageref{nZcopy}  \\  
-n/merge & p. \pageref{nZmerge}  & n/merge/col & p. \pageref{nZmergeZcol}  & n/pl & p. \pageref{nZpl}  \\  
-n/plot & p. \pageref{nZplot}  & n/proj & p. \pageref{nZproj}  & n/read & p. \pageref{nZread}  \\  
-n/scan & p. \pageref{nZscan}  & reset & p. \pageref{reset}  & v/deriv & p. \pageref{vZderiv}  \\  
-v/integ & p. \pageref{vZinteg}  & v/sort & p. \pageref{vZsort}  &   &   \\  
+h/2d/geth & p. \pageref{hZ2dZgeth}  & h/cadd & p. \pageref{hZcadd}  & h/cmult & p. \pageref{hZcmult}  \\  
+h/copy & p. \pageref{hZcopy}  & h/deriv & p. \pageref{hZderiv}  & h/err & p. \pageref{hZerr}  \\  
+h/get\_vec & p. \pageref{hZgetZvec}  & h/integ & p. \pageref{hZinteg}  & h/oper & p. \pageref{hZoper}  \\  
+h/plot/2d & p. \pageref{hZplotZ2d}  & h/put\_vec & p. \pageref{hZputZvec}  & h/rebin & p. \pageref{hZrebin}  \\  
+h/set/cont & p. \pageref{hZsetZcont}  & h/set/err & p. \pageref{hZsetZerr}  & n/assoc/col & p. \pageref{nZassocZcol}  \\  
+n/copy & p. \pageref{nZcopy}  & n/merge & p. \pageref{nZmerge}  & n/merge/col & p. \pageref{nZmergeZcol}  \\  
+n/pl & p. \pageref{nZpl}  & n/plot & p. \pageref{nZplot}  & n/proj & p. \pageref{nZproj}  \\  
+n/read & p. \pageref{nZread}  & n/scan & p. \pageref{nZscan}  & reset & p. \pageref{reset}  \\  
+v/deriv & p. \pageref{vZderiv}  & v/integ & p. \pageref{vZinteg}  & v/sort & p. \pageref{vZsort}  \\  
 \end{tabular} 
 \end{center} 
@@ -467,5 +467,5 @@
   (_nl is the table line number or the sequential index)
 - NTuple: ntuple variable names,_nl
-- Histo1D/HProf: i,x,val,err,_nl
+- Histo1D/HProf/HistoErr: i,x,val,err,nb,_nl
 - Histo2D: i,j,x,y,val,err,_nl
 - Vector/Matrix: n,r,c,val,real,imag,mod,phas,_nl
@@ -719,5 +719,5 @@
 Usage: readfits FileName [num_hdu] 
  num_hdu=1,..,NbHDU (uses FitsManager) 
-See also  scanfits writefits fitsadapt 
+See also  scanfits writefits fitsadapt swfitstable 
 \end{verbatim} 
 \piacommand{saveall} \label{saveall} 
@@ -753,4 +753,12 @@
 slev=1,3: header keywords , slev=2,3: try to read each HDU
 See also: readfits writefits fitsadapt 
+\end{verbatim} 
+\piacommand{swfitstable} \label{swfitstable} 
+\begin{verbatim} 
+swfitstable: Creates/read an SwFitsDataTable from a fits file
+   SwFitsDataTable is a table which uses the BINARY-TBL
+   of the fits file as swap space - useful for large tables
+Usage: swfitstable FileName [num_hdu=2] [segsize=512]
+See also: readfits scanfits
 \end{verbatim} 
 \piacommand{vecfrascii} \label{vecfrascii} 
@@ -1929,4 +1937,16 @@
 \subsection{pawCmd} \label{pawCmd} 
 \noindent 
+\piacommand{h/2d/geth} \label{hZ2dZgeth} 
+\begin{verbatim} 
+Get histo projections, bandes and slices
+ h/2d/geth nameh2d         : infos on 2D histogramme projections
+ h/2d/geth h nameh2d px    : copy X projection into histo h
+ h/2d/geth h nameh2d py    : copy Y projection into histo h
+ h/2d/geth h nameh2d bx n  : copy X band number n into histo h
+ h/2d/geth h nameh2d by n  : copy Y band number n into histo h
+ h/2d/geth h nameh2d sx n  : copy X slice number n into histo h
+ h/2d/geth h nameh2d sy n  : copy Y slice number n into histo h
+  Related commands: h/plot/2d
+\end{verbatim} 
 \piacommand{h/cadd} \label{hZcadd} 
 \begin{verbatim} 
@@ -2011,16 +2031,6 @@
  h/plot/2d nameh2d sx n [dopt] : plot X slice number n
  h/plot/2d nameh2d sy n [dopt] : plot Y slice number n
-                      n < 0 means Show Info\end{verbatim} 
-\piacommand{h/2d/geth} \label{hZ2dZgeth} 
-\begin{verbatim} 
-Get histo projections, bandes and slices
- h/2d/geth nameh2d         : infos on 2D histogramme projections
- h/2d/geth h nameh2d px    : copy X projection into histo h
- h/2d/geth h nameh2d py    : copy Y projection into histo h
- h/2d/geth h nameh2d bx n  : copy X band number n into histo h
- h/2d/geth h nameh2d by n  : copy Y band number n into histo h
- h/2d/geth h nameh2d sx n  : copy X slice number n into histo h
- h/2d/geth h nameh2d sy n  : copy Y slice number n into histo h
-  Related commands: h/plot/2d\end{verbatim} 
+                      n < 0 means Show Info
+\end{verbatim} 
 \piacommand{h/put\_vec} \label{hZputZvec} 
 \begin{verbatim} 